import { inject, ref, onBeforeUnmount } from 'vue'
import emitter from '/@/utils/emitter'
import { getProduct } from '../api'

export default function useSelectItem() {
  const profile = <any>inject('profile')

  const productSelect = ref('')
  emitter.on('ExchangeProduct-productSelect', (value: any) => {
    productSelect.value = value
  })

  const allData = ref([])
  emitter.on('ExchangeProduct-allData', (value: any) => {
    allData.value = value.value
  })

  const selectedIndex = ref(-1)
  const selectedParentAsin = ref('')
  const asinData = ref([])

  const selectedAsinIndex = ref(-1)
  const selectedAsin = ref('')
  const skuData = ref([])

  const selectedSkuIndex = ref(-1)
  const selectedSku = ref('')

  function selectPaAsin(index) {
    selectedIndex.value = index
    const selectedItem = allData.value[index]
    selectedParentAsin.value = selectedItem.parentAsin
    fetchAsin()
    selectedAsinIndex.value = -1
    skuData.value = []
  }

  async function fetchAsin() {
    const query = {
      profileId: profile.value.profile_id,
      productlineId: productSelect.value,
      parentAsin: selectedParentAsin.value,
    }
    try {
      const res = await getProduct(query)
      asinData.value = res.data
    } catch (error) {
      console.log('error:', error)
    }
  }

  function selectAsin(index) {
    selectedAsinIndex.value = index
    const selectedItem = asinData.value[index]
    selectedAsin.value = selectedItem.Asin
    fetchSku()
  }

  async function fetchSku() {
    const query = {
      profileId: profile.value.profile_id,
      productlineId: productSelect.value,
      parentAsin: selectedParentAsin.value,
      childAsin: selectedAsin.value,
    }
    try {
      const res = await getProduct(query)
      skuData.value = res.data
    } catch (error) {
      console.log('error:', error)
    }
  }

  function selectSku(index) {
    emitter.emit('useSelectItem-clickSkuItem')
    selectedSkuIndex.value = index
    const selectedItem = skuData.value[index]
    selectedSku.value = selectedItem.sku
  }

  function clickParentAsinBtn() {
    emitter.emit('useSelectItem-clickParentAsinBtn')
  }

  function clickAsinBtn() {
    emitter.emit('useSelectItem-clickAsinBtn')
  }

  onBeforeUnmount(() => {
    emitter.all.clear()
  })

  return { asinData, skuData, selectedIndex, selectedAsinIndex, selectedSkuIndex, selectPaAsin, selectAsin, selectSku, clickParentAsinBtn, clickAsinBtn }
}
